const hanspell = require('hanspell')

function toOrigin(first, origin) {
  first = first.trim()
  const phrase = first.split(' ')

  let j = 0
  return phrase.map((e, i) => {
    const v = origin.substring(j, j + e.length)
    j = j + e.length

    return v
  }).join(' ')
}

function setException(text) {
  text = text.replace(/졸본 특/g, '졸본특 ')
  text = text.replace(/호고 곡/g, '호고곡')
  text = text.replace(/하심시오/g, ' 하심시오')
  text = text.replace(/하심 시오/g, ' 하심시오')
  text = text.replace(/알 갯슴니다/g, '알겟슴니다')
  text = text.replace(/해라/g, ' 해라')
  text = text.replace(/ㅋ{2,}/g, ' ')

  return text
}

class filter {
  constructor() { }

  static trimming(text) {
    text = text.replace(/[~!@#$%^&*()_+|<>?:;'"{},.]/g, '')
    text = text.replace(/하심시오/g, '해라')
    text = text.replace(/심시오/g, '라')
    text = text.replace(/ /g, '')

    return text
  }

  static correct(text) {
    return new Promise((resolve, reject) => {
      if (!text) {
        resolve('')
      }

      let origin = filter.trimming(text)
      let first = origin
      let result = ''

      hanspell.spellCheckByDAUM(origin, 6000, data => {
        for (const d of data) {
          let blank = ''
          let suggestion = d.suggestions[0]

          if (d.type === 'space') {
            blank = ' '
          }
          first = first.replace(d.token + '', blank + suggestion)
        }

        result = toOrigin(first, origin)
        result = setException(result)

        resolve(result)
      }, () => { }, reject)
    })
  }

  static spacing(text, reg) {
    if (reg.test(text)) {
      const phrase = text.split(reg)
      const backup = text.match(reg)

      let j = 0
      text = phrase.map((e, i) => {
        if (j < backup.length) {
          return e + backup[j][0] + ' ' + backup[j++][1]
        } else {
          return e
        }
      }).join('')
    }

    return text
  }
}

module.exports = filter